//#include <stdio.h>
#include <errno.h>

#include "StdinSocket.h"
#include "StdLog.h"
#include <ISocketHandler.h>



StdinSocket::StdinSocket(ISocketHandler& h)
:Socket(h)
{
	Attach( STDIN_FILENO );
	Set(true, false, false);
}


StdinSocket::~StdinSocket()
{
}


void StdinSocket::OnRead()
{
	char buf[1000];
	int n = read(GetSocket(), buf, 999);
printf("read: %d\n", n);
	if (n == -1)
	{
		Handler().LogError(this, "OnRead", errno, strerror(errno), LOG_LEVEL_FATAL);
		SetCloseAndDelete();
		return;
	}
	for (size_t i = 0; i < (size_t)n; i++)
	{
		switch (buf[i])
		{
		case 13:
			break;
		case 10:
			OnLine(m_line);
			m_line = "";
			break;
		default:
			m_line += buf[i];
		}
	}
}


